#include "fchanger.h"

void Ltocwin::c_check(GtkWidget *widget)
{
  if (GTK_TOGGLE_BUTTON(widget)->active) flag_check=TRUE;
  else flag_check=FALSE;
  c_create_clist();
}
void Ltocwin::c_dir_check(GtkWidget *widget)
{
  if (GTK_TOGGLE_BUTTON(widget)->active) gtk_ftree_all_map(GTK_FTREE(ftree));
  else gtk_ftree_all_unmap(GTK_FTREE(ftree));
}

void Ltocwin::c_reload()
{
  c_ftree_write();
}

void Ltocwin::c_unselect()
{
  gtk_clist_unselect_all(GTK_CLIST(clist));
}

void Ltocwin::c_allselect()
{
  gtk_clist_select_all(GTK_CLIST(clist));
}

void Ltocwin::c_check_suffix(GtkWidget *widget)
{
  if(GTK_TOGGLE_BUTTON(widget)->active) 
    {
      flag_suffix=TRUE;

      gtk_widget_set_sensitive(check_input,FALSE);
      gtk_widget_set_sensitive(label_suffix,FALSE);
      gtk_widget_set_sensitive(combo,FALSE);
    }
  else 
    {
      flag_suffix=FALSE;
      if(flag_input==FALSE)
	gtk_widget_set_sensitive(check_input,TRUE);
      else
	{
	  gtk_widget_set_sensitive(check_input,TRUE);
	  gtk_widget_set_sensitive(label_suffix,TRUE);
	  gtk_widget_set_sensitive(combo,TRUE);
	}    
    }
}

void Ltocwin::c_check_input(GtkWidget *widget)
{
  if(GTK_TOGGLE_BUTTON(widget)->active) 
    {
      flag_input=TRUE;
      gtk_widget_set_sensitive(label_suffix,TRUE);
      gtk_widget_set_sensitive(combo,TRUE);
    }
  else
    {
      flag_input=FALSE;
      gtk_widget_set_sensitive(label_suffix,FALSE);
      gtk_widget_set_sensitive(combo,FALSE);
    }
}


void create_dialog()
{
  GtkWidget *dialog,*button;
  GtkWidget *label;
  GtkStyle *style;
  GdkColor col={0,0,0,0xffff};

  
  dialog=gtk_dialog_new();
  gtk_widget_set_usize(dialog,250,180);
  gtk_window_set_policy(GTK_WINDOW(dialog),FALSE,FALSE,FALSE);
  label=gtk_label_new("ե̾Ѵե");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),label,FALSE,FALSE,8);

  style= gtk_widget_get_style(label);
  style=gtk_style_copy(style);
  
  style->fg[0]=col;
  gdk_font_unref(style->font);
  style->font=gdk_fontset_load("-*-*-medium-r-normal-*-14-*-*-*-*-*-jisx0208.1983-0,-*-medium-r-normal-*-14-*,-*-*-*-*-*-*-14-*,*");

  gtk_widget_set_style(label,style);

  label=gtk_label_new("fchanger : version 0.2.2");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),label,FALSE,FALSE,4);
  
  style=gtk_widget_get_style(label);
  style=gtk_style_copy(style);
  
  col.blue=0;
  col.red=0xffff;  
  style->fg[0]=col;
  gtk_widget_set_style(label,style);
  
  
  label=gtk_label_new("Copyright (C) 2001 ƣ");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),label,FALSE,FALSE,4);
  gtk_signal_connect_object(GTK_OBJECT(dialog),"destroy",
		     GTK_SIGNAL_FUNC(gtk_grab_remove),GTK_OBJECT(dialog));

  label=gtk_label_new(" License : GNU GPL ");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),label,FALSE,FALSE,4);
  button=gtk_button_new_with_label("Close");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),button,
		     FALSE,FALSE,3);
  gtk_signal_connect_object(GTK_OBJECT(button),"clicked",
		     GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(dialog));
  GTK_WIDGET_SET_FLAGS(button,GTK_CAN_DEFAULT);
  gtk_widget_grab_default(button);
  gtk_grab_add(dialog);
  gtk_widget_show_all(dialog);
}


void Ltocwin::c_ftree_write()
{
  gchar *text;

  text=gtk_ftree_get_selected_path(GTK_FTREE(ftree));
  gtk_entry_set_text(GTK_ENTRY(textentry),text);

  c_create_clist();

  g_free(text);
}

void Ltocwin::c_textentry()
{

  gchar *text;
  GtkCTreeNode *node;

  text=gtk_entry_get_text(GTK_ENTRY(textentry));

  gtk_ftree_open(GTK_FTREE(ftree),text);

  text=gtk_ftree_get_selected_path(GTK_FTREE(ftree));
  
  node=gtk_ftree_get_selected_node(GTK_FTREE(ftree));
  if(GTK_VISIBILITY_NONE==gtk_ctree_node_is_visible(GTK_CTREE(ftree),node))
    gtk_ctree_node_moveto(GTK_CTREE(ftree),node,0,0.5,0);
  
  gtk_entry_set_text(GTK_ENTRY(textentry),text);

  c_create_clist();

  g_free(text);
}


void Ltocwin::c_filter()
{
  gtk_signal_emit_by_name(GTK_OBJECT(textentry),"activate");
}

void Ltocwin::c_create_clist()
{
  DIR *dir;
  struct dirent *ent;
  struct stat st;
  gchar *text[1],*path,*fil,cur[300];

  gtk_clist_freeze(GTK_CLIST(clist));

  gtk_clist_clear(GTK_CLIST(clist));

  path= gtk_entry_get_text(GTK_ENTRY(textentry));
  
  gtk_clist_set_column_justification(GTK_CLIST(clist),0,
				     GTK_JUSTIFY_LEFT);


  if((dir=opendir(path))==NULL) 
    {
      gtk_clist_set_column_justification(GTK_CLIST(clist),0,
					 GTK_JUSTIFY_CENTER);
      text[0]="****ե뤬ޤ!****\n";
      gtk_clist_append(GTK_CLIST(clist),text);
      gtk_clist_set_selectable(GTK_CLIST(clist),0,FALSE); 
      gtk_clist_thaw(GTK_CLIST(clist));
      closedir(dir);
      return;
    }

  fil=gtk_entry_get_text(GTK_ENTRY(filter));
  if(*fil=='\0') 
    {
      gtk_entry_set_text(GTK_ENTRY(filter),"*");
      fil="*";
    }


  getcwd(cur,300);
  chdir(path);

  while((ent=readdir(dir))!=NULL)
    {
      if((strcmp(ent->d_name,".")==0)||(strcmp(ent->d_name,"..")==0))
	continue;
      
      F_func f_tmp(ent->d_name,fil);

      if(flag_check==FALSE)
	{
	  if((ent->d_name[0]!='.')&&(f_tmp.filter_ok()!=-1))
	    {
	      stat(ent->d_name,&st);
	      if(!S_ISDIR(st.st_mode))
		{
		  text[0]=ent->d_name;
		  gtk_clist_append(GTK_CLIST(clist),text);
		}
	    }
	}
      else
	{
	  if(f_tmp.filter_ok()!=-1)
	    {
	      stat(ent->d_name,&st);
	      if(!S_ISDIR(st.st_mode))
		{
		  text[0]=ent->d_name;
		  gtk_clist_append(GTK_CLIST(clist),text);
		}
	    }
	}
    }
  
  if(gtk_clist_get_text(GTK_CLIST(clist),0,0,text)==FALSE)
    {
      gtk_clist_set_column_justification(GTK_CLIST(clist),0,
					 GTK_JUSTIFY_CENTER);
      text[0]="****ե뤬ޤ!****\n";
      gtk_clist_append(GTK_CLIST(clist),text);
      gtk_clist_set_selectable(GTK_CLIST(clist),0,FALSE); 
    }
  closedir(dir);
  chdir(cur);
  gtk_clist_sort(GTK_CLIST(clist));
  gtk_clist_thaw(GTK_CLIST(clist));

}



