#ifndef ___GTK_FTREE_H___
#define ___GTK_FTREE_H___

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C"{
#endif /* __cplusplus */

#define GTK_TYPE_FTREE         (gtk_ftree_get_type())
#define GTK_FTREE(obj)         (GTK_CHECK_CAST((obj),GTK_TYPE_FTREE,GtkFtree))
#define GTK_FTREE_CLASS(klass) (GTK_CHECK_CLASS_CAST((klass),GTK_TYPE_FTREE,GtkFtreeClass))
#define GTK_FTREE_ROW(_node_) ((GtkFtreeRow *)(((GList *)(_node_))->data))
#define GTK_FTREE_NODE(_node_) ((GtkFtreeNode *)((_node_)))

  
typedef struct _GtkFtree GtkFtree;
typedef struct _GtkFtreeClass GtkFtreeClass;
typedef struct _GtkFtreeRow GtkFtreeRow;
typedef struct _GtkFtreeNode GtkFtreeNode;
  
struct _GtkFtree
{
  GtkCTree      ctree;

  GdkPixmap 	*open_folder;
  GdkPixmap	*close_folder;
  GdkBitmap	*open_folder_mask;
  GdkBitmap	*close_folder_mask;
  gchar *current_path;
  guint flag:1;
};

struct _GtkFtreeClass
{
  GtkCTreeClass	parent_class;
};


GtkType gtk_ftree_get_type(void);
GtkWidget* gtk_ftree_new(void);

gint gtk_ftree_open(GtkFtree *ftree,gchar *path);
gchar* gtk_ftree_get_selected_path(GtkFtree*);
GtkCTreeNode* gtk_ftree_get_selected_node(GtkFtree* ftree);
void gtk_ftree_all_unmap(GtkFtree *ftree);
void gtk_ftree_all_map(GtkFtree *ftree);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ___GTK_FTREE_H___ */
